Description

Support Anfrage:

ich versuche gerade, in ADTF3 den Inhalt eines char* buffers als Media-Sample zu verschicken. Allerdings finde ich keine

Möglichkeit, die Buffer-Size mitzugeben.

Wie wäre der von der ADTF3 API vorgesehene Weg, für einen solchen Use-Case, ohne die Daten unnötig oft hin und her zu

kopieren.

C-Structs oder simple Datentypen würde ich normalerweise so versenden:

myType data; // struct to send

object_ptr<ISample> pWriteSample;

RETURN_IF_FAILED(alloc_sample(pWriteSample, timeStamp));

write_to_sample(*pWriteSample, data);

m_pinWriter << pWriteSample;

 Allerdings habe ich bei write_to_sample() keine Möglichkeit die größe der zu versendende Daten festzulegen. In der

Implementierung wird immer sizeOf(myType) verwendet. Daher habe ich die Implementierung von write_to_sample() als Basis für

eine eigene Send-Routine genommen:

tResult EthernetToRDB::SendSample(tTimeStamp timeStamp, const char* buffer, size_t size)

{

    {

        object_ptr<ISample> pWriteSample;

        RETURN_IF_FAILED(alloc_sample(pWriteSample, timeStamp));

        // modified version of write_to_sample() to support sending only part of the buffer

        adtf::ucom::object_ptr_locked<ISampleBuffer> pSampleBuffer;

        RETURN_IF_FAILED(pWriteSample->WriteLock(pSampleBuffer, size));

        adtf::base::adtf_memory<const char, size> mem(buffer);

        pSampleBuffer->Write(mem);

        m_rdbPinWriter << pWriteSample;

    }

    RETURN_NOERROR;

}

 Hier scheitere ich allerdings daran, das bei der Instanziierung von adtf_memory der Parameter size offenbar konstant sein muss.

Wie wäre die korrekte Lösung über die ADTF3-API?

Lösung:

Das geht mit adtf_memory_buffer:
adtf::ucom::object_ptr_locked<ISampleBuffer> pSampleBuffer;

RETURN_IF_FAILED(oSample.WriteLock(pSampleBuffer, nDataSize));

return pSampleBuffer->Write(adtf::base::adtf_memory_buffer<const tVoid>(pDataPointer, nDataSize));

History

#1 - 2018-10-01 12:54 - hidden

- Topic set to ADTF::Common

#2 - 2018-10-01 12:58 - hidden

- Status changed from New to In Progress

Hallo Martin,

kannst Du bei dieser Anfrage weiterhelfen?

#3 - 2018-10-01 13:03 - hidden

Das geht ganz einfach mit adtf_memory_buffer:

adtf::ucom::object_ptr_locked<ISampleBuffer> pSampleBuffer;

RETURN_IF_FAILED(oSample.WriteLock(pSampleBuffer, sizeof(oValue)));

return pSampleBuffer->Write(adtf::base::adtf_memory_buffer<const tVoid>(pDataPointer, nDataSize));

#4 - 2018-10-01 13:04 - hidden

Das muss natürlich

RETURN_IF_FAILED(oSample.WriteLock(pSampleBuffer, nDataSize));

 lauten.

#5 - 2018-10-01 13:21 - hidden

- Status changed from In Progress to Customer Feedback Required

Hallo Christian,

siehe die Kommentare von Martin.

Bitte in jeden Fall um Feedback.

Danke.

#6 - 2018-10-04 09:11 - hidden

Hallo Christian,

wurde deine Anfrage beantwortet?

Bitte um Feedback bis zum 05.10.2018

Danke

#7 - 2018-10-04 13:14 - hidden

Hallo Matthias,

Frage wurde beantwortet. Funktioniert wie gewünscht. Ticket kann geschlossen werden.

Vielen Dank!

Christian

#8 - 2018-10-04 13:24 - hidden

- Subject changed from Sample aus char* buffer befüllen to Fill sample from char* buffer and include buffer size 

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue
#9 - 2018-10-09 13:08 - hidden

- Project changed from 20 to Public Support

- Status changed from To Be Closed to Closed

- Private changed from Yes to No

Powered by TCPDF (www.tcpdf.org)

2024-04-18 3/3

http://www.tcpdf.org

